<?php
// $Id: utils.php 330 2008-02-03 16:26:13Z Hal9000 $

/** ensure this file is being included by a parent file */
defined( '_VALID_PARENT' ) or die( 'Direct Access to this location is not allowed.' );

/* -------------------------------.
	General use utility functions |
   -------------------------------
*/

/* Sorts an array by field */
function sort_by_field($a,$f,$t) 
{
	$s1 = array(); $s2 = array();
	
	$x = (@func_get_arg(3) ? func_get_arg(3) : "0");
	$count = ($x == "0" ? count($a) - 1 : count($a));
	for ($i = $x; $i <= $count; $i++)
	{
		$s1[$i] = $a[$i][$f];
	}
	natcasesort($s1);
	if (eregi("^(2|desc)$",$t))
	{
		$s1 = array_reverse($s1,TRUE);
	}
	$i = $x; 
	foreach ($s1 as $k => $v)
	{
		$s2[$i++] = $a[$k];
	}
	return $s2;
}

/* Returns an array containing number of days, hours, minutes and seconds */
function seconds_to_time($seconds)
{
   $days = 0;
   $hours = 0;
   $minutes = 0;
   while ($seconds >= 60) {
       if ($seconds >= 86400) {
           // there is more than 1 day
           $days = floor($seconds / 86400);
           $seconds = $seconds - ($days * 86400);
       } elseif ($seconds >= 3600) {
           $hours = floor($seconds / 3600);
           $seconds = $seconds - ($hours * 3600);
       } elseif ($seconds >= 60) {
           $minutes = floor($seconds / 60);
           $seconds = $seconds - ($minutes * 60);
       }
   }
   return array('days' => $days, 'hours' => $hours, 'minutes' => $minutes, 'seconds' => $seconds);
}

/* Parses a given string for irc control codes and returns it in xhtml 1.0 strict markup language */
function denora_colorconvert($log)
{
	global $charset;
	
	$color["color:0;"] = "color:#FFFFFF;";
	$color["color:1;"] = "color:#000000;";
	$color["color:2;"] = "color:#00007F;";
	$color["color:3;"] = "color:#009300;";
	$color["color:4;"] = "color:#FF0000;";
	$color["color:5;"] = "color:#7F0000;";
	$color["color:6;"] = "color:#9C009C;";
	$color["color:7;"] = "color:#FC7F00;";
	$color["color:8;"] = "color:#FFFF00;";
	$color["color:9;"] = "color:#00FC00;";
	$color["color:10;"]= "color:#009393;";
	$color["color:11;"]= "color:#00FFFF;";
	$color["color:12;"]= "color:#0000FC;";
	$color["color:13;"]= "color:#FF00FF;";
	$color["color:14;"]= "color:#7F7F7F;";
	$color["color:15;"]= "color:#D2D2D2;";
	
	/* Wrap the text to avoid overflowing the layout */
	/* If the second parameter of this function is 0, wrapping will be skipped */
	$numargs = func_num_args();
	$arg_list = func_get_args();
	$wrap = ($numargs > 1) ? $arg_list[1] : 1;
	if ($wrap == 1) {
		$log = str_replace(chr(03), ' ' . chr(03), $log);
		$log = preg_replace('#([^\n\r ]{60})#i', '\\1  ', $log);
	}
	
	/* Transform the text into xhtml */
	$log = @htmlentities($log,ENT_COMPAT,$charset);
	$log = nl2br($log);
	
	$ctrl->k = chr(03);
	while(ereg("$ctrl->k([0-9]{1,2}),([0-9]{1,2})([^$ctrl->k]*)$ctrl->k([:alpha:])",$log))
	{
		$log = ereg_replace("$ctrl->k([0-9]{1,2}),([0-9]{1,2})([^$ctrl->k]*)$ctrl->k","<span style=\"color:\\1; background-color:\\2;\">\\3</span>",$log);
	}
	while(ereg("$ctrl->k([0-9]{1,2}),([0-9]{1,2})(.*)",$log))
	{
		$log = ereg_replace("$ctrl->k([0-9]{1,2}),([0-9]{1,2})(.*)","<span style=\"color:\\1; background-color:\\2;\">\\3</span>",$log);
	}
	while(ereg("$ctrl->k([0-9]{1,2})([^$ctrl->k]*)$ctrl->k([0-9]{1,2})",$log))
	{
		$log = ereg_replace("$ctrl->k([0-9]{1,2})([^$ctrl->k]*)$ctrl->k([0-9]{1,2})","<span style=\"color:\\1;\">\\2</span>$ctrl->k\\3",$log);
	}
	while(ereg("$ctrl->k([0-9]{1,2})([^$ctrl->k]*)$ctrl->k",$log))
	{
		$log = ereg_replace("$ctrl->k([0-9]{1,2})([^$ctrl->k]*)$ctrl->k","<span style=\"color:\\1;\">\\2</span>",$log);
	}
	while(ereg("$ctrl->k([0-9]{1,2})(.*)",$log))
	{
		$log = ereg_replace("$ctrl->k([0-9]{1,2})(.*)","<span style=\"color:\\1;\">\\2</span>",$log);
	}
	$log = strtr($log,$color);
	
	$ctrl_b = chr(02);
	$log = ereg_replace("$ctrl_b([^\r$ctrl_b]*)[$ctrl_b]","<span style=\"font-weight: bold;\">\\1</span>",$log);
	$log = ereg_replace("$ctrl_b([^\r$ctrl_b]*)","<span style=\"font-weight: bold;\">\\1</span>\r",$log);
	$ctrl_u = chr(31);
	$log = ereg_replace("$ctrl_u([^\r$ctrl_u]*)[$ctrl_u]","<span style=\"text-decoration: underline;\">\\1</span>",$log);
	$log = ereg_replace("$ctrl_u([^\r$ctrl_u]*)","<span style=\"text-decoration: underline;\">\\1</span>\r",$log);
	$ctrl_i = chr(22);
	$log = ereg_replace("$ctrl_i([^\r$ctrl_i]*)[$ctrl_i]","<span style=\"font-style: italic;\">\\1</span>",$log);
	$log = ereg_replace("$ctrl_i([^\r$ctrl_i]*)","<span style=\"font-style: italic;\">\\1</span>\r",$log);
	$ctrl_s = chr(18);
	$log = ereg_replace("$ctrl_s([^\r$ctrl_s]*)[$ctrl_s]","<span style=\"text-decoration: line-through;\">\\1</span>",$log);
	$log = ereg_replace("$ctrl_s([^\r$ctrl_s]*)","<span style=\"text-decoration: line-through;\">\\1</span>\r",$log);
	for ($i = 0; $i < 32; $i++)	{ $log = str_replace(chr($i), "", $log); }
	for ($i = 127; $i < 256; $i++)	{ $log = str_replace(chr($i), "&nbsp;", $log); }
	
	$log = ereg_replace("[[:alpha:]]+://[^<>[:space:]]+[[:alnum:]/]","<a href=\"\\0\" class=\"topic\">\\0</a>", $log);
	$log = ereg_replace("(^| )(www([-]*[.]?[^<>[:space:]]+[[:alnum:]/])*)","\\1<a href=\"http://\\2\" class=\"topic\">\\2</a>", $log);
	
	return $log;
}

/* Returns the Denora version. Used by the setup page. */
function phpdenora_versioncheck($server,$what)
{
	global $denora_server_db;
	$q = sql_query("SELECT version FROM ".$denora_server_db." WHERE server='".$server."';");
	$r = sql_fetch_array($q);
	switch ($what) {
		case 'full':
			return $r[0];
			break;
		case 'num':
			$pattern = '/([0-9.]+)/';
			preg_match($pattern, $r[0], $num);
			return @$num[1];
			break;
		case 'ext':
			$pattern = '/([0-9.]+)/';
			preg_match($pattern, $r[0], $num);
			if (!$num) {
				$pattern = '/\-(.*)\s/';
				preg_match($pattern, $r[0], $ext);
			} else {
				$ext = explode("(",substr($r[0], 0, -1));	
			}
			return @$ext[1];
			break;
		case 'rev':
			$pattern = '/([0-9.]+)/';
			preg_match($pattern, $r[0], $num);
			if (!$num) {
				$rev = explode("(",substr($r[0], 0, -1));
			} else {
				$pattern = '/(\.[0-9]+)\s/';
				preg_match($pattern, $r[0], $rev);
				$rev[1] = substr($rev[1], 1);
			}
			return @$rev[1];
			break;
		default:
			return NULL;
 	}
}

/* Error handling function */
function phpdenora_error($what,$info)
{
	global $theme, $tpl_err_error, $tpl_err_warning, $tpl_err_info;
	$info = $info ? $info : _ER_NODATA;
	switch ($what) {
		case 1:
			$icon = $tpl_err_error[0];
			$title = "<h3 class=\"center\" style=\"color:red\">"._ER_ERROR."</h3>";
			$message = sprintf(_ER_MODE,"<br />\"<span class=\"color\">$info</span>\"<br />");
			break;
		case 2:
			$icon = $tpl_err_warning[0];
			$title = "<h3 class=\"center\" style=\"color:orange\">"._ER_WARNING."</h3>";
			$message = $info;
			break;
		case 3:
			$icon = $tpl_err_info[0];
			$title = "<h3 class=\"center\" style=\"color:blue\">"._ER_INFO."</h3>";
			$message = $info;
			break;
		default:
			$icon = $tpl_err_error[0];
			$title = "<h3 class=\"center\" style=\"color:red\">"._ER_ERROR."</h3>";
			$message = "Unknown internal error";
	}
	echo "<div class=\"error\">
		<table class=\"error\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\">
			<tr>
				<td class=\"lerr\" align=\"center\">
					<img src=\"themes/$theme/img/$icon\" alt=\"\" />
					$title
				</td>
				<td class=\"rerr\" align=\"center\">
					<p class=\"center\">$message</p>
				</td>
			</tr>
		</table>
	</div>";
}

?>
