<?php
// $Id: remote.php 349 2009-03-03 17:04:14Z hal9000 $
// Read the documentation in docs/REMOTE for how to use the remote functionalities

define( '_VALID_PARENT', 1 );

require ("libs/phpdenora/init.php");	# Load the initialization functions

switch ($pd_enremote) {
	case true:
		$func = isset($_GET['func']) ? htmlspecialchars($_GET['func']) : exit;
		$param = isset($_GET['param']) ? htmlspecialchars($_GET['param']) : NULL;
		switch ($func) {
			/* Network Stats */
			case 'currentstats':
				$currentstats = phpdenora_current();
				for ($i = 0; $i < 5; $i++) {
					echo $currentstats['value'][$i] . "\t" . $currentstats['time'][$i] . "\n";
				}
				break;
			case 'maxstats':
				$maxstats = phpdenora_maxstats();
				for ($i = 0; $i < 4; $i++) {
					echo $maxstats['value'][$i] . "\t" . $maxstats['time'][$i] . "\n";
				}
				break;
			case 'topusers':
				$topusers = phpdenora_topusers($param);
				foreach($topusers as $topuser) {
					echo $topuser['user'] . "\n";
				}
				break;
			case 'topchans':
				$topchans = phpdenora_topchans($param);
				foreach($topchans as $topchan) {
					echo $topchan['chan'] . "\n";
				}
				break;
			/* Server Stats */
			case 'serverlist':
				$serverlist = denora_server_array(0);
				foreach ($serverlist as $server) {
					echo $server['server'] . "\n";
				}
				break;
			/* Channel Stats */
			case 'chanlist':
				$chanlist = phpdenora_chanlist($param);
				foreach ($chanlist as $chan) {
					echo $chan['chan'] . "\t";
					echo $chan['users'] . "\t";
					echo $chan['topic'] . "\n";
				}
				break;
			case 'userlist':
				$userlist = denora_who_in_channel($param);
				foreach($userlist as $user) {
					echo $user['nick'] . "\n";
				}
				break;
			case 'numinchan':
				echo denora_num_in_chan($param);
				break;
			case 'chanpeak':
				$chanpeak = denora_peak_chan($param);
				echo @$chanpeak['maxusers'] . "\n";
				echo @$chanpeak['maxusertime'] . "\n";
				break;
			case 'chantopic':
				$chantopic = denora_get_chan_topic($param);
				echo denora_colorconvert($chantopic['topic']) . "\n";
				echo $chantopic['topicauthor'] . "\n";
				echo strtotime($chantopic['topictime']) . "\n";
				break;
			/* User Stats */
			case 'operlist':
				$operlist = denora_get_opers();
				foreach ($operlist as $oper) {
					echo $oper['nick'] . "\n";
				}
				break;
			case 'seenuser':
				$seenuser = phpdenora_seenuser($param);
				foreach ($seenuser[1] as $user) {
					echo $user['nick'] . "\t";
					echo $user['realname'] . "\t";
					echo $user['username'] . "\t";
					echo $user['hostname'] . "\t";
					echo $user['online'] . "\t";
					echo $user['away'] . "\t";
					echo $user['connecttime'] . "\t";
					echo $user['lastquit'] . "\t";
					echo $user['uline'] . "\n";
				}
				break;
			default: exit;
		}
		break;
	default: exit;
}

?>